\chapter{Functional Enhancements}


\section{Changes to Whisker-Web}

\subsection{Changes to the Interface}
The web interface includes a new input, which allows the user to set the acceleration factor manually. It defaults to an acceleration factor of 1, meaning no acceleration. Changing the value will be saved in the local storage as with the other options.

\begin{figure}[H]
  \centering
  \includegraphics[width=0.8\linewidth]{./figures/whisker_screenshot_acceleration_factor_cropped.png}
  \caption{The added input at the end of the Whisker-Web configuration options allows to set a custom acceleration factor.}
\end{figure}




\subsection{The Servant}

\subsection{General Usage}
To make testing easier, the author added several command line options wrapping the Puppeteer based script into a file named \texttt{servant.js} in the \texttt{./servant} folder of the whisker-web repository. The Servant supports the following command line arguments:

\begin{lstlisting}[language=BASH]
$ > node servant.js -h
Usage: servant [options]

Options:
  -u, --whiskerURL <URL>              File URL of the Whisker instance to run the
                                      tests (default: "../dist/index.html")
  -s, --scratchPath <Path>            Scratch application to run (default: false)
  -t, --testPath <Path>               Tests to run (default: false)
  -a, --accelerationFactor <Integer>  Acceleration factor (default: 1)
  -d, --isHeadless                    If should run headless (d like in decapitated)
  -p, --numberOfTabs <Integer>        The number of tabs to execute the tests in
                                      (default: 1)
  -c, --isConsoleForwarded            If the browsers console output should be
                                      forwarded (default: false)
  -o, --isLifeOutputCoverage          If the new output of the coverage should be
                                      printed regularly (default: false)
  -l, --isLifeLogEnabled              If the new output of the log should be printed
                                      regularly (default: false)
  -h, --help                          output usage information
\end{lstlisting}

For example the following command
\begin{lstlisting}
node servant -s ./CatchGame.sb3 -t ./CatchGameTests.js -a 1 -d -p 8 -l -o -c
\end{lstlisting}
will execute the test-suite defined in \texttt{./CatchGameTests.js} on the project defined in \texttt{./CatchGame.sb3} with an acceleration factor of 1 (\texttt{-a 1}), in the headless mode (\texttt{-d} as in \textit{decapitated}), in 8 tabs (\texttt{-p 8}), while forwarding the output of \texttt{console.log} in the Google Chrome tabs to the shell instance the \texttt{servant.js} is executed in (\texttt{-c}). Additonally the coverage report (\texttt{-o}) and the Test Driver log (\texttt{-l}) are also fowarded to the shell instance as those are updated in Whisker-Web.

The Servant also validates necessary command-line arguments. The \texttt{scratchPath} and the \texttt{testPath} arguments have to exist, while the maximum argument supplied for \texttt{numberOfTabs} must be smaller or equal to the available threads/CPUs. If one of the validation fails, the Servant will automatically cancel the run and exit with an appropriate error message.


\subsection{Passing data between the Servant and Whisker-Web}
When the Servant starts a Whisker-Web instance, it attaches a callback to the window object of the Whisker-Web tab. The Whisker-Web instance calls this callback after the tests have been finished. The coverage and summary of the test run are passed as parameters to the callback, which can then be used by the Servant.

In the future, this interface can be used to pass whatever data necessary, as long as it is serializable. To pass data from a tab controlled by Puppeteer to the Servant, the data has to be serialized, as the objects have to move from the browsers execution context to the Node.js based execution context.




\section{Changes to Whisker-Main}

\subsection{Test Driver Enhancements}
The following methods have been added to the test-driver and are available to test-suite developers.

\begin{lstlisting}[language=ES6]
const {coveredBlocks, totalBlocks} = t.getCoverage();
\end{lstlisting}
The \texttt{t.getCoverage()} method returns the coverage of the Scratch application at the time the callback is called. A possible usecase is a test, which should be finshed at a specific coverage. This was also used for evaluation to end a test when a 100 \% coverage was reached.

\begin{lstlisting}[language=ES6]
const realTimePassedSinceStarted = t.getTotalRealTimeElapsed();
const realTimePassedSinceLastRun = t.getRealRunTimeElapsed();
\end{lstlisting}
\texttt{t.getTotalTimeElapsed()} returns the total application time which has been ellapsed since the application has been started, while \texttt{t.getRunTimeElapsed()} the time since the last run. If the test is executed with the default acceleration factor of 1, the return value of this function after 60 seconds in realtime will also be 60 seconds, but when run with an acceleration factor of 10 only 6 seconds, as the application time is passing by faster. To allow the user to still measure the real time which passed by two new methods have been added to return the real time without the acceleration factor. This way the acceleration factor will not change the time returned by those new functions.

\begin{lstlisting}[language=ES6]
const accelerationFactor = t.getAccelerationFactor();
\end{lstlisting}
\texttt{t.getAccelerationFactor()} returns the acceleration factor, for example \texttt{10} at an acceleration factor of 10.


\subsection{Changes to the VMWrapper}
The changes to the VMWrapper class hold the logic to incorporate the acceleration factor used in the methods of the VMWrapper class.

The major changes are:
\begin{itemize}
  \item overwriting the default \texttt{Runtime.THREAD\_STEP\_INTERVAL} representing the Scratch VM frequency and setting the user defined acceleration factor supplied in the Whisker Web interface,

  \item the instrumentation functions for primitives and devices\newline
  \texttt{instrumentDevice (deviceName, method)}\newline
  \texttt{instrumentPrimitive (primitive, argument)}\newline
  which get called in the \texttt{async setup (project)} setup method of the VMWrapper.

  \item modifying the \texttt{getTotalTimeElapsed()} and \texttt{getRunTimeElapsed()} methods to incorporatethe acceleration factor

  \item and the \texttt{setStepTime} function, which is also called in the setup method of the VMWrapper, to incorporate the acceleration factor and set the frequency of the Scratch VM.
\end{itemize}
